StatementCache (Apache Tomcat 11.0.5 API Documentation)
Description: declaration: package: org.apache.tomcat.jdbc.pool.interceptor, class: StatementCache

# Class StatementCache

java.lang.Object
org.apache.tomcat.jdbc.pool.JdbcInterceptor
org.apache.tomcat.jdbc.pool.interceptor.AbstractCreateStatementInterceptor
org.apache.tomcat.jdbc.pool.interceptor.StatementDecoratorInterceptor
org.apache.tomcat.jdbc.pool.interceptor.StatementCache

All Implemented Interfaces:
  `InvocationHandler`, `StatementCacheMBean`

public class StatementCache extends StatementDecoratorInterceptor implements StatementCacheMBean
Interceptor that caches `PreparedStatement` and/or `CallableStatement` instances on a connection.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `StatementCache.CachedStatement`

  ### Nested classes/interfaces inherited from class org.apache.tomcat.jdbc.pool.interceptor.StatementDecoratorInterceptor

  `StatementDecoratorInterceptor.ResultSetProxy, StatementDecoratorInterceptor.StatementProxy<T extends Statement>`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String[]`
  `ALL_TYPES`
  `protected static final String[]`
  `CALLABLE_TYPE`
  `protected static final String[]`
  `NO_TYPE`
  `protected static final String[]`
  `PREPARED_TYPE`
  `protected static final String`
  `STATEMENT_CACHE_ATTR`

  ### Fields inherited from class org.apache.tomcat.jdbc.pool.interceptor.StatementDecoratorInterceptor

  `EXECUTE_QUERY, GET_GENERATED_KEYS, GET_RESULTSET, RESULTSET_TYPES, resultSetConstructor`

  ### Fields inherited from class org.apache.tomcat.jdbc.pool.interceptor.AbstractCreateStatementInterceptor

  `constructors, CREATE_STATEMENT, CREATE_STATEMENT_IDX, EXECUTE, EXECUTE_BATCH, EXECUTE_TYPES, EXECUTE_UPDATE, GET_STATEMENT, PREPARE_CALL, PREPARE_CALL_IDX, PREPARE_STATEMENT, PREPARE_STATEMENT_IDX, RESULTSET_IDX, STATEMENT_TYPE_COUNT, STATEMENT_TYPES`

  ### Fields inherited from class org.apache.tomcat.jdbc.pool.JdbcInterceptor

  `CLOSE_VAL, EQUALS_VAL, GETCONNECTION_VAL, HASHCODE_VAL, ISCLOSED_VAL, ISVALID_VAL, ISWRAPPERFOR_VAL, properties, TOSTRING_VAL, UNWRAP_VAL`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StatementCache()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `cacheStatement(StatementCache.CachedStatement proxy)`
  `void`
  `closeStatement(StatementCache.CachedStatement st)`
  `protected org.apache.tomcat.jdbc.pool.interceptor.StatementCache.CacheKey`
  `createCacheKey(Method method, Object[] args)`
  `protected org.apache.tomcat.jdbc.pool.interceptor.StatementCache.CacheKey`
  `createCacheKey(String methodName, Object[] args)`
  `protected Object`
  `createDecorator(Object proxy, Method method, Object[] args, Object statement, Constructor<?> constructor, String sql)`
  Creates a proxy for a Statement.
  `void`
  `disconnected(ConnectionPool parent, PooledConnection con, boolean finalizing)`
  Called when `Connection.close()` is called on the underlying connection.
  `protected ConcurrentHashMap<org.apache.tomcat.jdbc.pool.interceptor.StatementCache.CacheKey,StatementCache.CachedStatement>`
  `getCache()`
  `AtomicInteger`
  `getCacheSize()`
  `int`
  `getCacheSizePerConnection()`
  `int`
  `getMaxCacheSize()`
  `String[]`
  `getTypes()`
  `Object`
  `invoke(Object proxy, Method method, Object[] args)`
  Gets invoked each time an operation on `Connection` is invoked.
  `boolean`
  `isCacheCallable()`
  `StatementCache.CachedStatement`
  `isCached(Method method, Object[] args)`
  `boolean`
  `isCachePrepared()`
  `void`
  `poolClosed(ConnectionPool pool)`
  This method is invoked by a connection pool when the pool is closed.
  `void`
  `poolStarted(ConnectionPool pool)`
  This method is invoked by a connection pool when the pool is first started up, usually when the first connection is requested.
  `boolean`
  `removeStatement(StatementCache.CachedStatement proxy)`
  `void`
  `reset(ConnectionPool parent, PooledConnection con)`
  no-op for this interceptor. no state is stored.
  `void`
  `setProperties(Map<String,PoolProperties.InterceptorProperty> properties)`
  Called during the creation of an interceptor The properties can be set during the configuration of an interceptor Override this method to perform type casts between string values and object properties

  ### Methods inherited from class org.apache.tomcat.jdbc.pool.interceptor.StatementDecoratorInterceptor

  `closeInvoked, createStatement, getResultSetConstructor, isExecuteQuery, isExecuteQuery, isResultSet`

  ### Methods inherited from class org.apache.tomcat.jdbc.pool.interceptor.AbstractCreateStatementInterceptor

  `getConstructor, isExecute, isStatement, process`

  ### Methods inherited from class org.apache.tomcat.jdbc.pool.JdbcInterceptor

  `compare, compare, getNext, getProperties, isUseEquals, setNext, setUseEquals`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### ALL_TYPES

    protected static final String[] ALL_TYPES

  - ### CALLABLE_TYPE

    protected static final String[] CALLABLE_TYPE

  - ### PREPARED_TYPE

    protected static final String[] PREPARED_TYPE

  - ### NO_TYPE

    protected static final String[] NO_TYPE

  - ### STATEMENT_CACHE_ATTR

    protected static final String STATEMENT_CACHE_ATTR

- ## Constructor Details

  - ### StatementCache

    public StatementCache()

- ## Method Details

  - ### isCachePrepared

    public boolean isCachePrepared()
    Specified by:
      `isCachePrepared` in interface `StatementCacheMBean`

  - ### isCacheCallable

    public boolean isCacheCallable()
    Specified by:
      `isCacheCallable` in interface `StatementCacheMBean`

  - ### getMaxCacheSize

    public int getMaxCacheSize()
    Specified by:
      `getMaxCacheSize` in interface `StatementCacheMBean`

  - ### getTypes

    public String[] getTypes()

  - ### getCacheSize

    public AtomicInteger getCacheSize()
    Specified by:
      `getCacheSize` in interface `StatementCacheMBean`

  - ### setProperties

    public void setProperties(Map<String,PoolProperties.InterceptorProperty> properties)
    Description copied from class: `JdbcInterceptor`
    Called during the creation of an interceptor The properties can be set during the configuration of an interceptor Override this method to perform type casts between string values and object properties
    Overrides:
      `setProperties` in class `JdbcInterceptor`
    Parameters:
      `properties` - The properties

  - ### poolStarted

    public void poolStarted(ConnectionPool pool)
    Description copied from class: `JdbcInterceptor`
    This method is invoked by a connection pool when the pool is first started up, usually when the first connection is requested. Interceptor classes can override this method if they keep static variables or other tracking means around. This method is only invoked on a single instance of the interceptor, and not on every instance created.
    Overrides:
      `poolStarted` in class `JdbcInterceptor`
    Parameters:
      `pool` - - the pool that is being closed.

  - ### poolClosed

    public void poolClosed(ConnectionPool pool)
    Description copied from class: `JdbcInterceptor`
    This method is invoked by a connection pool when the pool is closed. Interceptor classes can override this method if they keep static variables or other tracking means around. This method is only invoked on a single instance of the interceptor, and not on every instance created.
    Overrides:
      `poolClosed` in class `JdbcInterceptor`
    Parameters:
      `pool` - - the pool that is being closed.

  - ### reset

    public void reset(ConnectionPool parent, PooledConnection con)
    Description copied from class: `AbstractCreateStatementInterceptor`
    no-op for this interceptor. no state is stored.
    Overrides:
      `reset` in class `AbstractCreateStatementInterceptor`
    Parameters:
      `parent` - - the connection pool owning the connection
      `con` - - the pooled connection

  - ### disconnected

    public void disconnected(ConnectionPool parent, PooledConnection con, boolean finalizing)
    Description copied from class: `JdbcInterceptor`
    Called when `Connection.close()` is called on the underlying connection. This is to notify the interceptors, that the physical connection has been released. Implementation of this method should be thought through with care, as no actions should trigger an exception.
    Overrides:
      `disconnected` in class `JdbcInterceptor`
    Parameters:
      `parent` - - the connection pool that this connection belongs to
      `con` - - the pooled connection that holds this connection
      `finalizing` - - if this connection is finalizing. True means that the pooled connection will not reconnect the underlying connection

  - ### closeStatement

    public void closeStatement(StatementCache.CachedStatement st)

  - ### createDecorator

    protected Object createDecorator(Object proxy, Method method, Object[] args, Object statement, Constructor<?> constructor, String sql) throws InstantiationException, IllegalAccessException, InvocationTargetException
    Description copied from class: `StatementDecoratorInterceptor`
    Creates a proxy for a Statement.
    Overrides:
      `createDecorator` in class `StatementDecoratorInterceptor`
    Parameters:
      `proxy` - The proxy object on which the method that triggered the creation of the statement was called.
      `method` - The method that was called on the proxy
      `args` - The arguments passed as part of the method call to the proxy
      `statement` - The statement object that is to be proxied
      `constructor` - The constructor for the desired proxy
      `sql` - The sql of of the statement
    Returns:
      A new proxy for the Statement
    Throws:
      `InstantiationException` - Couldn't instantiate object
      `IllegalAccessException` - Inaccessible constructor
      `InvocationTargetException` - Exception thrown from constructor

  - ### invoke

    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable
    Description copied from class: `JdbcInterceptor`
    Gets invoked each time an operation on `Connection` is invoked.
    Specified by:
      `invoke` in interface `InvocationHandler`
    Overrides:
      `invoke` in class `AbstractCreateStatementInterceptor`
    Throws:
      `Throwable`

  - ### isCached

    public StatementCache.CachedStatement isCached(Method method, Object[] args)

  - ### cacheStatement

    public boolean cacheStatement(StatementCache.CachedStatement proxy)

  - ### removeStatement

    public boolean removeStatement(StatementCache.CachedStatement proxy)

  - ### getCache

    protected ConcurrentHashMap<org.apache.tomcat.jdbc.pool.interceptor.StatementCache.CacheKey,StatementCache.CachedStatement> getCache()

  - ### getCacheSizePerConnection

    public int getCacheSizePerConnection()
    Specified by:
      `getCacheSizePerConnection` in interface `StatementCacheMBean`

  - ### createCacheKey

    protected org.apache.tomcat.jdbc.pool.interceptor.StatementCache.CacheKey createCacheKey(Method method, Object[] args)

  - ### createCacheKey

    protected org.apache.tomcat.jdbc.pool.interceptor.StatementCache.CacheKey createCacheKey(String methodName, Object[] args)